#ifndef _DIFFUSION_HEADER_INCLUDE_
#define _DIFFUSION_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <opencv/cv.h>
#include <opencv/highgui.h>

using namespace std;
using namespace cv;

#define MAX_OCTAVES 24

#define OCTAVE_SCALE 18
#define OCTAVE_OFFSET 6

#define ANISO_COEFF_FACTOR 0.25
#define ANISO_MASK_THRES 2.0

bool processEvents();

void dPyramidGaussianBlur(IplImage *image, IplImage *mask, int octaves);

void dAnisotripicDiffusion( IplImage *image, IplImage *mask = NULL, int iter = 15 );

#endif