#include <cstdio>
#include <cstdlib>
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include "Image.h"
#include "Inpaint.h"
#include "Diffusion.h"
#include "Contour.h"
#include "Interface.h"
#include "Toolbar.h"

using namespace std;
using namespace cv;

Inpainter globalInpainter;

bool processEvents() {
    MSG windowMessage;
    while( PeekMessage (&windowMessage, NULL, 0, 0, PM_REMOVE) ) {
        TranslateMessage (&windowMessage);
        DispatchMessage (&windowMessage);
    }
    return programState == STATE_FREE;
}

int WINAPI WinMain (HINSTANCE hThisInstance, HINSTANCE hPrevInstance, 
                    LPSTR lpszArgument, int nFunsterStil) {
    windowSetup( hThisInstance );
    MSG windowMessage;
    while(!programQuit) {
        if (PeekMessage (&windowMessage, NULL, 0, 0, PM_REMOVE)) {
            TranslateMessage (&windowMessage);
            DispatchMessage (&windowMessage);
        } else {
            if(programState == STATE_RUN ) {
                globalInpainter.inpaint();
            } else {
                cvWaitKey(5);
            }
        }
        windowUpdate();
    }
}